Public Class Form1

    Dim cellSize As Integer = 20 ' Z̃TCY
    Dim sx As Integer = 16 ' tB[h̕
    Dim sy As Integer = 16 ' tB[h̍
    Dim numMine As Integer = 40 ' e̐

    Const UNOPEN As Integer = -2
    Const MINE As Integer = -1

    Dim numCellOpened As Integer ' JZ̐
    Dim gameStarted As Boolean ' Q[JnĂ邩

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' ȉ̓vpeBEEBhEłݒ\
        dgv.ReadOnly = True
        dgv.ColumnHeadersVisible = False
        dgv.RowHeadersVisible = False
        dgv.AllowUserToResizeColumns = False
        dgv.AllowUserToResizeRows = False
        dgv.AllowUserToAddRows = False
        dgv.ShowCellToolTips = False ' Ȃ悤

        ' tB[h̍쐬
        dgv.RowTemplate.Height = cellSize ' ǉs̍
        dgv.ColumnCount = sx
        dgv.RowCount = sy

        For Each col As DataGridViewColumn In dgv.Columns
            col.Width = cellSize
        Next

        ' tH[̃TCYDGVɍ킹
        Dim cell As DataGridViewCell = dgv(0, 0)
        Me.ClientSize = New Size( _
         cell.Size.Width * sx + 3, _
         cell.Size.Height * sy + 3)

        initGame()
    End Sub

    ' Q[̏
    Sub initGame()
        numCellOpened = 0
        gameStarted = True

        ' ׂẴZ̏
        For x As Integer = 0 To sx - 1
            For y As Integer = 0 To sy - 1
                dgv(x, y).Value = UNOPEN
                dgv(x, y).Style.ForeColor = Color.WhiteSmoke
                dgv(x, y).Style.BackColor = Color.WhiteSmoke
            Next
        Next

        ' e̔zu
        Dim rnd As New Random
        Dim doneNum As Integer = 0
        While doneNum < numMine
            Dim x As Integer = rnd.Next(sx)
            Dim y As Integer = rnd.Next(sy)
            If CInt(dgv(x, y).Value) <> MINE Then
                dgv(x, y).Value = MINE
                doneNum += 1
            End If
        End While

        showRemain()
    End Sub

    ' cZiJĂȂZj̕\
    Sub showRemain()
        ' e̐Ǝc̃Z̐Ɛ
        Me.Text = "eF" & numMine _
            & " c̃ZF" & (sx * sy - numCellOpened)
    End Sub

    ' (x, y)ObhɊ܂܂邩
    Function isInField(ByVal x As Integer, ByVal y As Integer)
        If x < 0 Or y < 0 Or x >= sx Or y >= sy Then
            Return False
        End If
        Return True
    End Function

    ' cellɗאڂZzŕԂ
    Function getNeighbors(ByVal cell As DataGridViewCell)
        Dim x As Integer = cell.ColumnIndex
        Dim y As Integer = cell.RowIndex
        Dim cc As New List(Of DataGridViewCell)

        If isInField(x - 1, y - 1) Then cc.Add(dgv(x - 1, y - 1))
        If isInField(x - 1, y + 1) Then cc.Add(dgv(x - 1, y + 1))
        If isInField(x + 1, y - 1) Then cc.Add(dgv(x + 1, y - 1))
        If isInField(x + 1, y + 1) Then cc.Add(dgv(x + 1, y + 1))
        If isInField(x - 1, y) Then cc.Add(dgv(x - 1, y))
        If isInField(x + 1, y) Then cc.Add(dgv(x + 1, y))
        If isInField(x, y - 1) Then cc.Add(dgv(x, y - 1))
        If isInField(x, y + 1) Then cc.Add(dgv(x, y + 1))

        Return cc.ToArray()
    End Function

    ' Z̕\
    Sub drawNumberCell(ByVal cell As DataGridViewCell)
        cell.Style.BackColor = Color.LightGray
        If CInt(cell.Value) = 0 Then
            ' 0͕\ȂiwiFŕ`j
            cell.Style.ForeColor = Color.LightGray
        Else
            ' 1`8̐
            cell.Style.ForeColor = Color.Blue
        End If
    End Sub

    ' ZJƂ
    Sub tryCell(ByVal cell As DataGridViewCell)
        If gameStarted = False Then
            Return
        End If
        If CInt(cell.Value) = MINE Then
            gameOver(False)
        ElseIf CInt(cell.Value) = UNOPEN Then
            openCell(cell)
            showRemain()
            If numCellOpened = sx * sy - numMine Then
                gameOver(True)
            End If
        End If
    End Sub

    ' ZJ
    Sub openCell(ByVal cell As DataGridViewCell)
        numCellOpened += 1
        Dim count As Integer = 0

        ' ̔e̐𐔂
        For Each c As DataGridViewCell In getNeighbors(cell)
            If CInt(c.Value) = MINE Then
                count += 1
            End If
        Next

        ' ̔e̐\
        cell.Value = count
        drawNumberCell(cell)

        ' ̃ZɔeȂꍇÃZJ
        If count = 0 Then
            For Each c As DataGridViewCell In getNeighbors(cell)
                If CInt(c.Value) = UNOPEN Then
                    openCell(c) ' ċAĂяo
                End If
            Next
        End If
    End Sub

    Sub gameOver(ByVal isSuccess As Boolean)
        gameStarted = False
        Me.Text = "F2L[ŃgC"

        ' eʒu̕\
        For x As Integer = 0 To sx - 1
            For y As Integer = 0 To sy - 1
                If CInt(dgv(x, y).Value) = MINE Then
                    dgv(x, y).Value = ""
                    dgv(x, y).Style.BackColor = IIf(isSuccess, Color.Green, Color.Red)
                End If
            Next
        Next
    End Sub

    ' DGVKeyDownCxgEnh
    Private Sub dgv_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles dgv.KeyDown
        If e.KeyCode = Keys.F2 Then
            initGame()
        End If
        If e.KeyCode = Keys.Space Then
            tryCell(dgv.CurrentCell)
        End If
    End Sub

    ' DGVCellClickCxgEnh
    Private Sub dgv_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv.CellClick
        tryCell(dgv(e.ColumnIndex, e.RowIndex))
    End Sub

    ' DGVSelectionChangedCxgEnh
    Private Sub dgv_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dgv.SelectionChanged
        ' ZIԂɂȂ
        dgv.ClearSelection()
    End Sub
End Class
